VERSION 2.00
Begin Form Setup1 
   BackColor       =   &H00400000&
   Caption         =   "Test Installationsprogramm"
   ControlBox      =   0   'False
   FillStyle       =   0  'Gefllt
   FontBold        =   -1  'True
   FontItalic      =   -1  'True
   FontName        =   "MS Sans Serif"
   FontSize        =   24
   FontStrikethru  =   0   'False
   FontUnderline   =   0   'False
   ForeColor       =   &H00000000&
   Height          =   2535
   Icon            =   0
   Left            =   1620
   LinkMode        =   1  'Quelle
   LinkTopic       =   "Form3"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   142
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   376
   Top             =   4260
   Width           =   5760
   Begin Label Label2 
      BorderStyle     =   1  'nicht nderbar, einfach
      Caption         =   "Um dieses Installationsprogramm an Ihre Bedrfnisse anzupassen, modifizieren Sie die FORM_LOAD-Ereignisprozedur."
      Height          =   435
      Left            =   15
      TabIndex        =   1
      Top             =   15
      Visible         =   0   'False
      Width           =   5625
   End
   Begin Label Label1 
      BorderStyle     =   1  'nicht nderbar, einfach
      Caption         =   "Dieses Bezeichnungsfeld wird zur DDE-Verknpfung mit dem Programm-Manager verwendet."
      Height          =   390
      Left            =   15
      TabIndex        =   0
      Top             =   525
      Visible         =   0   'False
      Width           =   5610
   End
End

Const APPNAME = "biorhythmus"
Const APPDIR = "C:\CS"    ' Das Standard-Installationsverzeichnis

' Setze die Gesamtgre der dekomprimierten Dateien,
' indem die Gren der einzelnen Dateien addiert werden.
Const WINSYSNEEDED = 360000  ' Dateien, die in den Verzeichnissen WINDOWS und SYSTEM installiert werden
Const OTHERNEEDED = 20000   ' Dateien, die nicht in den Verzeichnissen WINDOWS und SYSTEM installiert werden

Sub DrawBackground ()
    Setup1.CurrentY = 5
    Setup1.CurrentX = 5
    Setup1.ForeColor = QBColor(15)
    Print APPNAME + " Installation"
End Sub

Sub Form_Load ()
    
    '--------------
    ' Initialisiere
    '--------------
    dialogCaption$ = APPNAME + " Installation "
    ShowMainForm dialogCaption$
    
    '---------------------------------------------------------------
    ' SETUP.EXE bergibt das Quellaufwerk in einem Befehlsargument.
    ' Wenn es leer ist, bedeutet dies, da der Benutzer diese EXE-
    ' Datei direkt ausgefhrt hat. Zeige in diesem Fall ein
    ' Dialogfeld an, um das gewnschte Quellverzeichnis zu erhalten.
    '---------------------------------------------------------------
    SourcePath$ = Command$
    If SourcePath$ = "" Then
        title$ = dialogCaption$
        caption1$ = "Geben Sie bitte das Laufwerk oder den Pfad an, in dem die Quelldateien der " + APPNAME + " enthalten sind."
        caption2$ = "Installieren von:"
        defaultDrive$ = "A:"
        defaultText$ = "A:\"

        ShowPathDialog title$, caption1$, caption2$, defaultDrive$, defaultText$, SourcePath$, outButton$

        If outButton$ = "exit" Then GoTo ErrorSetup
    Else
        If Right$(SourcePath$, 1) <> "\" Then
            SourcePath$ = SourcePath$ + "\"
        End If
    End If


    '---------------------
    ' Rufe den Zielpfad ab
    '---------------------
    title$ = dialogCaption$
    caption1$ = "Wenn Sie die Testanwendung in einem anderen Verzeichnis und/oder Laufwerk installieren mchten, geben Sie den Namen des gewnschten Verzeichnisses ein."
    caption2$ = "Installieren in:"
    defaultDrive$ = "C:"
    defaultText$ = APPDIR

    ShowPathDialog title$, caption1$, caption2$, defaultDrive$, defaultText$, destPath$, outButton$

    If outButton$ = "exit" Then GoTo ErrorSetup
    
    '----------------------------
    ' Beispieldialogfeld Optionen
    '----------------------------
'    ReDim Caption(1 To 4) As String
'    ReDim choice(1 To 4) As Integer
'
'    title$ = dialogCaption$
'    numOptions = 4
'    Caption(1) = "Beispieloption 1"
'    Caption(2) = "Beispieloption 2"
'    Caption(3) = "Beispieloption 3"
'    Caption(4) = "Beispieloption 4"
'    helpTxt$ = "Whlen Sie Ihre Optionen. Diese Optionen werden in diesem Installationsprogramm nicht wirklich verwendet, doch aus dem Code von SETUP1.FRM geht hervor, wie Sie Ihre eigenen Options-Dialogfelder implementieren knnen."

'    ShowOptionDialog title$, numOptions, Caption$(), helpTxt$, choice(), outButton$

'    If outButton$ = "exit" Then
'        GoTo ErrorSetup
'    Else
'        If choice(1) Then MsgBox "Option 1 ausgewhlt", 48, "INSTALLATION"
'        If choice(2) Then MsgBox "Option 2 ausgewhlt", 48, "INSTALLATION"
'        If choice(3) Then MsgBox "Option 3 ausgewhlt", 48, "INSTALLATION"
'        If choice(4) Then MsgBox "Option 4 ausgewhlt", 48, "INSTALLATION"
'    End If


    '-------------------------------------------------
    ' Dimensioniere Variablen fr freien Speicherplatz
    ' auf der Festplatte als Long Integers.
    '-------------------------------------------------
    Dim winSpaceFree As Long
    Dim sourceSpaceFree As Long
    Dim destSpaceFree As Long
    Dim totalNeeded As Long

    winDir$ = GetWindowsDir$()
    winSysDir$ = GetWindowsSysDir$()

    '--------------------------------------------------------------
    ' Wenn das Windows-Verzeichnis \SYSTEM ein Unterverzeichnis
    ' des Windows-Verzeichnisses ist, werden .VBX- und Shared .DLL-
    ' Dateien in diesem Verzeichnis installiert.
    '
    ' Wenn das Windows-Verzeichnis \SYSTEM KEIN Unterverzeichnis
    ' des Windows-Verzeichnisses ist, fhrt der Benutzer eine
    ' gemeinsam verwendete Version von Windows aus. In diesem
    ' Fall werden .VBX- und Shared .DLL-Dateien im Windows-
    ' Verzeichnis installiert.
    '--------------------------------------------------------------
    If InStr(winSysDir$, winDir$) = 0 Then
        winSysDir$ = winDir$
    End If

    
    '---------------------------------------
    ' Rufe das Laufwerk der Verzeichnisse ab
    '---------------------------------------
    winDrive$ = UCase$(Left$(winDir$, 1))
    destDrive$ = UCase$(Left$(destPath$, 1))
    sourceDrive$ = UCase$(Left$(SourcePath$, 1))

    '--------------------------------------
    ' Berechne die Variablen fr den auf
    ' der Festplatte freien Speicherplatz.
    '-------------------------------------
    winSpaceFree = GetDiskSpaceFree(winDrive$)
    destSpaceFree = GetDiskSpaceFree(destDrive$)
    
    '----------------------------------------------------------------------
    ' Prfe, ob gengend Platz auf der Festplatte zur Verfgung steht.
    '
    ' Einige Komponenten werden im Windows-Verzeichnis \SYSTEM installiert.
    '
    ' Wenn sich der Hauptzielpfad auf einem anderen Laufwerk wie das
    ' Windows-Verzeichnis \SYSTEM befindet, mssen daher beide Laufwerke
    ' geprft werden.
    '
    ' Dies ist beispielsweise dann der Fall, wenn der Benutzer das
    ' Programm in Laufwerk D installiert und das Windows-Verzeichnis
    ' sich in Laufwerk C befindet.
    ' ---------------------------------------------------------------------
    totalNeeded = WINSYSNEEDED + OTHERNEEDED
    
    If winDrive$ = destDrive$ Then
        If destSpaceFree < totalNeeded Then
            MsgBox "In Laufwerk " + destDrive$ + ": steht nicht gengend Speicherplatz zur Verfgung. Etwa " + Str$(totalNeeded - destSpaceFree) + " Byte werden zustzlich bentigt.", 16, dialogCaption$
            GoTo ErrorSetup
        End If
    Else
        If winSpaceFree < WINSYSNEEDED Then
            MsgBox "In Laufwerk " + winDrive$ + ": steht nicht gengend Speicherplatz zur Verfgung. Etwa " + Str$(WINSYSNEEDED - winSpaceFree) + " Byte werden zustzlich bentigt.", 16, dialogCaption$
            GoTo ErrorSetup
        End If
        If destSpaceFree < OTHERNEEDED Then
            MsgBox "In Laufwerk " + destDrive$ + ":  steht nicht gengend Speicherplatz zur Verfgung. Etwa " + Str$(OTHERNEEDED - destSpaceFree) + " Byte werden zustzlich bentigt.", 16, dialogCaption$
            GoTo ErrorSetup
        End If
        
    End If



    '-----------------------------
    ' Erstelle das Zielverzeichnis
    '-----------------------------
    If Not CreatePath(destPath$) Then GoTo ErrorSetup
    


    '---------------------------------------------------
    ' Zeige das Status-Dialogfeld an -- es wird whrend
    ' des gesamten Kopiervorgangs angezeigt und wird von
    ' der CopyFile-Routine bentigt.
    '---------------------------------------------------
    ShowStatusDialog dialogCaption$, totalNeeded
    
    
    '----------------
    ' Kopiere Dateien
    '----------------

    ' Prfe, ob sich LOAN.EXE auf der Diskette befindet. Wenn dies nicht der
    ' Fall ist, hat der Benutzer nicht die erste Diskette eingelegt.
    If Not PromptForNextDisk(1, SourcePath$ + "bior1.exe") Then GoTo ErrorSetup
    ' Installiere LOAN.EXE und GRID.VBX im destPath$
    If Not CopyFile(SourcePath$, destPath$, "bior1.exe", "bior1.exe") Then GoTo ErrorSetup
    If Not CopyFile(SourcePath$, destPath$, "bioinfo.txt", "bioinfo.txt") Then GoTo ErrorSetup

    ' Wenn Sie mehrere Auslieferungsdisketten haben, rufen Sie PromptForNextDisk
    ' auf, nachdem Sie alle Dateien von der vorhergehenden Diskette installiert
    ' haben. Diese Zeile prft, ob sich FOO.DA_ auf Diskette 2 befindet.
    ' Wenn dies nicht der Fall ist, hat der Benutzer nicht die Diskette 2
    ' eingelegt. Der Aufruf von PromptForNextDisk wurde mit einem Kommentar-
    ' zeichen versehen, da LOAN.EXE von einer einzigen Auslieferungsdiskette
    ' aus installiert werden kann.
    
    ' If Not PromptForNextDisk(2, SourcePath$ + "foo.da_") Then GoTo ErrorSetup
    ' If Not CopyFile(SourcePath$, destPath$, "foo.da_", "foo.dat", 0) Then GoTo ErrorSetup


    '--------------------------------------------
    ' Das Kopieren von Dateien ist abgeschlossen.
    ' Entlade daher das Status-Dialogfeld.
    '--------------------------------------------
    Unload StatusDlg


    '-----------------------------------------------------
    ' Zeige eine statische Meldung an, whrend DDE mit dem
    ' Programm-Manager eingerichtet wird.
    '-----------------------------------------------------
    ShowStaticMessageDialog dialogCaption$, "Das Symbol im Programm-Manager wird erstellt..."


    '-------------------------------------------------------
    ' Erstelle Programmgruppe und Symbol im Programm-Manager
    '-------------------------------------------------------
    CreateProgManGroup Setup1, "biorhythmus", "bior1.GRP"
    CreateProgManItem Setup1, destPath$ + "bior1.EXE", "biorhythmus"


    '-------------------------------------------------------------------
    ' Da SETUP.EXE Ihr Installationsprogramm in das Windows-Verzeichnis
    ' kopiert, kann Ihr Benutzer dieses Programm direkt ausfhren.
    '
    ' Als hilfreiches Merkmal knnen Sie an dieser Stelle Code einfgen,
    ' der ein Symbol im Programm-Manager installiert, mit dem Ihr
    ' Installationsprogramm im Windows-Laufwerk ausgefhrt wird.
    ' Hierdurch kann die Installation zu einem spteren Zeitpunkt
    ' erneut ausgefhrt werden, wenn beim ersten Mal noch nicht alle
    ' Optionen installiert wurden.
    '-------------------------------------------------------------------

    '----------------------------------
    ' Blende die statische Meldung aus.
    '----------------------------------
    MessageDlg.Hide
    

    '------------------------------
    ' Zeige die Abschlumeldung an.
    '------------------------------
    MsgBox APPNAME + "Die Installation wurde erfolgreich abgeschlossen!", 48, dialogCaption$

ExitSetup:
    Setup1.Hide
    RestoreProgMan         'Zeige den Programm-Manager an.
    End
    Exit Sub

ErrorSetup:
    MsgBox APPNAME + " wurde nicht ordnungsgem installiert. Fhren Sie die Installation zu einem spteren Zeitpunkt erneut durch, um die Anleihe-Anwendung richtig zu installieren.", 48, dialogCaption$
    End
    Exit Sub
    
End Sub

Sub Form_Paint ()
    DrawBackground
End Sub

'-------------------------------------------
' Setze das Bezeichnungsfeld der Form, zeige
' Hintergrundtext in 3D an die Form an.
'-------------------------------------------
Sub ShowMainForm (Caption$)
    Screen.MousePointer = 11
    Setup1.Caption = Caption$
    Setup1.Move 0, 0, Screen.Width, Screen.Height * .85
    Setup1.Show
    Setup1.Refresh

    Setup1.ScaleMode = 2
    Setup1.FontSize = 24
    Setup1.FontBold = True
    Setup1.FontItalic = True
    
    DrawBackground
End Sub

Sub ShowPathDialog (title$, caption1$, caption2$, defaultDrive$, defaultText$, SourcePath$, outButton$)
        Screen.MousePointer = 11
        Load PathDlg
        PathDlg.Caption = title$
        PathDlg.Label1.Caption = caption1$
        PathDlg.Label2.Caption = caption2$
        PathDlg.inDrive.Tag = defaultDrive$
        PathDlg.Text1.Text = defaultText$
        PathDlg.Text1.SelStart = 0
        PathDlg.Text1.SelLength = Len(defaultText$)
        CenterForm PathDlg
        Screen.MousePointer = 0

        PathDlg.Show 1
        
        SourcePath$ = PathDlg.outPath.Tag
        outButton$ = PathDlg.outButton.Tag
        Unload PathDlg
End Sub

Sub ShowStaticMessageDialog (title$, Caption$)

    Load MessageDlg
    CenterForm MessageDlg
    MessageDlg.Caption = title$
    MessageDlg.Label.Caption = Caption$
    MessageDlg.Show
    MessageDlg.Refresh

End Sub

Sub ShowStatusDialog (title$, totalBytes As Long)

    Load StatusDlg
    StatusDlg.Caption = title$
    StatusDlg.total.Tag = Str$(totalBytes)
    CenterForm StatusDlg
    StatusDlg.Show

End Sub

